<?php 
defined('BASEPATH') OR exit('No direct script access allowed');

$CI = get_instance();
$pengaturan = $CI->model('sipas/pengaturan', true);

// use ldap
$config['use_ldap'] = false;

// penomoran strict
$config['penomoran_urut_internal'] = 1; // 1 = urut OR 0 = bebas
$config['penomoran_urut_eksternal'] = 1; // 1 = urut OR 0 = bebas
// Penomoran
$config['urutan_penomoran'] = 'surat_tanggal'; // surat_tanggal or surat_setuju_tgl

// value backdate
$config['backdate_value'] = 'huruf_besar'; // huruf_besar, huruf_kecil, angka, romawi

$config['huruf_kecil'] = array( 'a', 'b', 'c', 'd', 'e',
                                'f', 'g', 'h', 'i', 'j',
                                'k', 'l', 'm', 'n', 'o',
                                'p', 'q', 'r', 's', 't',
                                'u', 'v', 'w', 'x', 'y',
                                'z'
                        );
$config['huruf_besar'] = array( 'A', 'B', 'C', 'D', 'E',
                                'F', 'G', 'H', 'I', 'J',
                                'K', 'L', 'M', 'N', 'O',
                                'P', 'Q', 'R', 'S', 'T',
                                'U', 'V', 'W', 'X', 'Y',
                                'Z'
                        );
$config['romawi']      = array( 'I', 'II', 'III', 'IV', 'V',
                                'VI', 'VII', 'VIII', 'IX', 'X',
                                'XI', 'XII', 'XIII', 'XIV', 'XV',
                                'XVI', 'XVII', 'XVIII', 'XIX', 'XX',
                                'XXI', 'XXII', 'XXIII', 'XXIV', 'XXV',
                                'XXVI'
                        );


// Redis
$config['useredis'] = 0 ;// 1 = true OR 0 = false

if($config['useredis']  == 1){
    $config['redis'] = new Redis(); 
    $config['redis']->connect('127.0.0.1', 6379);
    $config['redis']->auth("password");
}else{
    $config['redis'] = null;
}
$config['redisPrefix'] = 'sipas_unmul_5_40:';

$config['upload_staf_config'] = array(
    'imagePath' => './data/staf/',
    'imageDefaultPath' => './assets/staf_default/',
    'imageSmallName' => 'thumb',
    'imageSmallSizeWidth' => '32',
    'imageSmallSizeHeight' => '32',
    'imageBigSizeWidth' => '200',
    'imageBigSizeHeight' => '200',
    'imageExt' => 'jpg'
);

$config['upload_staf_ttd_config'] = array(
    'imagePath' => './data/staf_ttd/',
    'imageDefaultPath' => './assets/staf_default/',
    'imageSmallName' => 'thumb',
    'imageSmallSizeWidth' => '32',
    'imageSmallSizeHeight' => '32',
    'imageBigSizeWidth' => '200',
    'imageBigSizeHeight' => '200',
    'imageExt' => 'jpg'
);
$config['mobile_version'] = array(
    '5.01','5.10','5.20','5.21','5.22','5.30','5.40','5.42'
);
$config['queueServer'] = array(
    'host'=>null,
    'port'=>'11300'
);
$config['queueServer_notifType'] = array(
    'notif_sipas_unmul'
);
$config['queueServer_notifTypeRedis'] = array(
    'notif_sipas_unmul_redis'
);
$config['queueServer_formatTube'] = array(
    'logMessageFormat'=>'NOTIF {status} {payload}',
    'logPath'=>APPPATH.'logs/notif/',
    'logStrategy'=>'daily'
);
$config['queueServer_formatTubeRedis'] = array(
    'logMessageFormat'=>'REDIS {status} {payload}',
    'logPath'=>APPPATH.'logs/redis/',
    'logStrategy'=>'daily'
);
$config['queueServer_notifTube'] = 'notif_sipas_unmul'; 
$config['queueServer_notifTubeRedis'] = 'notif_sipas_unmul_redis';
$config['queueServer_mailTube'] = 'mail';
$config['queueServer_smsTube'] = 'sms';

$config['notif_token'] = '';
$config['notif_url'] = 'https://fcm.googleapis.com/fcm/send';

//=======================================//
//             Queue Helper              //
//=======================================//
// Tube used by the feature //
$config['queueServer_tubes'] = array(
    "hcm_integration"   => array('sipas_5_30_hcm')
);
// Default model data accepted by the service controller //
$config['queueServer_modelData'] = array(
    "hcm_integration"   => array('logged_user', 'entity', 'action', 'record', 'batchId')
);
// default log template for the service //
$config['queueServer_formatTubes'] = array(
    "hcm_integration" => array(
        'logMessageFormat'=>'Integrasi HCM {status} {payload}',
        'logPath'=>APPPATH.'logs/hcm/',
        'logStrategy'=>'daily'
    )
);
//=======================================//
//           Queue Helper End            //
//=======================================//

//=======================================//
//      PostgreSQL And HCM Config        //
//=======================================//
// initialize db type used by base_model, haven't found other method //
$config['use_postgresql'] = false;
/* hcm api point to request data to, without the entity, entity is handled by controller.
   still used my playground for testing */
$config['hcm_api_point'] = null;
/* if created_at, modified_at and destroyed_at is null, then the record is being inserted to db,
   recommended false. if false, the record will be sent to log without any process to db*/
$config['hcm_safeSync'] = false;
/* used to be recorded to properti, string for staf_id, multidimensional array staf_id, and other needed data. 
   not finished yet, need to add jabatan and unit*/
$config['hcm_sync_loggeduser'] = '1';
/* list of entity to be synced by hcm. 
   please don't change the position of the array element for priority data being processed */
$config['hcm_synced_entity'] = array('unit', 'jabatan', 'staf');
//=======================================//
//     PostgreSQL And HCM Config END     //
//=======================================//

$config['upload_config'] = array(
    'upload_path'   => './data/dokumen/',
    'view_path'   => 'server/data/dokumen/',
    'allowed_types' => 'gif|jpg|jpeg|png|bmp|tiff|doc|docx|xls|xlsx|pdf|rtf|txt|ppt|pptx|pps|zip|rar|7z',
    'max_size'      => 200000,
    'encrypt_name'  => TRUE,
    'overwrite'     => TRUE
);
$config['preview_config'] = array(
    'maintain_ratio'    => TRUE,
    'width'             => 220,
    'height'            => 300
);

$config['mime_previewable'] = array(
    'image/jpg',
    'image/jpeg',
    'image/pjpeg',
    'image/png',
    'image/x-png',
);

$config['mime_imageconstructor'] = array(
    'image/jpeg'            => 'imagecreatefromjpeg',
    'image/pjpeg'           => 'imagecreatefromjpeg',
    'image/png'             => 'imagecreatefrompng',
    'image/x-png'           => 'imagecreatefrompng',
    'image/gif'             => 'imagecreatefromgif',
    'image/bmp'             => 'imagecreatefromwbmp',
    'image/x-windows-bmp'   => 'imagecreatefromwbmp',
);

$config['previewUrl'] = 'server.php/sipas/dokumen/preview/{dokumen_id}';
$config['viewUrl'] = 'server.php/sipas/dokumen/view/{dokumen_id}'; 
$config['downloadUrl'] = 'server.php/sipas/dokumen/download/{dokumen_id}';
$config['extPath'] = 'assets/surat_default/ext{ext}.png';
$config['extDefaultPath'] = 'assets/surat_default/ext.default.png';

$config['logopath'] = './data/sistem/';
$config['leftlogo_url'] = '/sipas/asset/inst_logo/template_header_leftlogo.png';        
$config['rightlogo_url'] = '/sipas/asset/inst_logo/template_header_rightlogo.png';
$config['logo1_url'] = '/sipas/asset/inst_logo/template_header_logo1.png';
$config['logo2_url'] = '/sipas/asset/inst_logo/template_header_logo2.png';
$config['logo3_url'] = '/sipas/asset/inst_logo/template_header_logo3.png';
$config['logo4_url'] = '/sipas/asset/inst_logo/template_header_logo4.png';
$config['logo5_url'] = '/sipas/asset/inst_logo/template_header_logo5.png';

$config['leftlogo_path'] = 'data/sistem/template_header_leftlogo.png';
$config['rightlogo_path'] = 'data/sistem/template_header_rightlogo.png';
$config['logo1_path'] = 'data/sistem/template_header_logo1.png';
$config['logo2_path'] = 'data/sistem/template_header_logo2.png';
$config['logo3_path'] = 'data/sistem/template_header_logo3.png';
$config['logo4_path'] = 'data/sistem/template_header_logo4.png';
$config['logo5_path'] = 'data/sistem/template_header_logo5.png';


$config['chiper'] = 'sekawanmediainformatika';
// patch for v3.1 security concept 
$config['token_chiper'] = 'sekawanmediainformatika';

$config['token_key'] = 'Authorization';

$config['access_route'] = array(
    /*
    0 = public
    1 = only for authenticated user
    2 = only for authorized user
    3 = only for current user
    4 = only for system */
    
    //token
    array('token',      0, array('sipas/account/registerToken',
                                'sipas/account/deviceLogin')),
    //account
    array('session',    1, array(
                            'sipas/account',
                            'sipas/account/index',
                            'sipas/account/profile_update',
                            'sipas/account/surat_keluar',
                            'sipas/account/surat_keluar/read',
                            'sipas/account/surat_keluar/scope',
        					'sipas/account/surat_keluar/draft',
        					'sipas/account/surat_keluar/dlm_setuju',
        					'sipas/account/surat_keluar/setuju',
        					'sipas/account/surat_keluar/revisi',
        					'sipas/account/surat_keluar/tolak',
        					'sipas/account/surat_keluar/blm_nomor',
        					'sipas/account/surat_keluar/blm_ekspedisi',
        					'sipas/account/surat_keluar/ekspedisi',
                            'sipas/account/surat_ikeluar',
                            'sipas/account/surat_ikeluar/read',
        					'sipas/account/surat_ikeluar/draft',
        					'sipas/account/surat_ikeluar/dlm_setuju',
        					'sipas/account/surat_ikeluar/setuju',
        					'sipas/account/surat_ikeluar/revisi',
        					'sipas/account/surat_ikeluar/blm_nomor',
        					'sipas/account/surat_ikeluar/blm_kirim',
        					'sipas/account/surat_ikeluar/blm_terima',
        					'sipas/account/surat_ikeluar/terima',
        					'sipas/account/surat_ikeluar/tolak',
                            'sipas/account/masuk',
                            'sipas/account/masuk_blmbaca',
                            'sipas/account/masuk_baca',
                            'sipas/account/masuk_terus',
                            'sipas/account/koreksi',
                            'sipas/account/koreksi_blmtindak',
                            'sipas/account/koreksi_setuju',
                            'sipas/account/koreksi_tolak',
                            'sipas/account/disposisi',
                            'sipas/account/disposisi_blmbaca',
                            'sipas/account/disposisi_baca',
                            'sipas/account/disposisi_terus',
        					'sipas/account/disposisi_nonaktif',
                            'sipas/account/notadinas',
                            'sipas/account/notadinas_blmbaca',
                            'sipas/account/notadinas_baca',
                            'sipas/account/notadinas_terus',
        					'sipas/account/notadinas_nonaktif',
                            'sipas/account/pengajuan_koreksi',
                            'sipas/account/monitored_staf',
                            'sipas/account/asistensi',
                            'sipas/account/asistensi/masuk',
                            'sipas/account/asistensi/disposisi',
                            'sipas/account/asistensi/disposisi_blmbaca',
                            'sipas/account/asistensi/disposisi_baca',
                            'sipas/account/asistensi/disposisi_terus',
        					'sipas/account/asistensi/disposisi_nonaktif',
                            'sipas/account/asistensi/notadinas',
                            'sipas/account/asistensi/notadinas/notadinas_blmbaca',
                            'sipas/account/asistensi/notadinas/notadinas_baca',
                            'sipas/account/asistensi/notadinas/notadinas_terus',
        					'sipas/account/asistensi/notadinas/notadinas_nonaktif',
                            'sipas/account/asistensi/masuk_baca',
                            'sipas/account/asistensi/masuk_blmbaca',
                            'sipas/account/asistensi/masuk_terus',
        					'sipas/account/asistansi/riwayat',
                            'sipas/account/asistensi/riwayat_aktif',
        					'sipas/account/asistensi/riwayat_nonaktif',
                            'sipas/account/asistensi/koreksi',
                            'sipas/account/asistensi/koreksi_blmtindak',
                            'sipas/account/asistensi/koreksi_setuju',
                            'sipas/account/asistensi/koreksi_tolak',
                            'sipas/account/riwayat',
                            'sipas/account/riwayat_aktif',
                            'sipas/account/riwayat_nonaktif',
                            'sipas/account/verify_token',
        					// 'sipas/account/register_token',
        					'sipas/account/remove_token',
                            'sipas/account/requestDevice',
                            // 'sipas/account/deviceLogin',
                            'sipas/account/changepassword',
                            'sipas/account/info',
                            'sipas/account/gen_password',
                            'sipas/account/scope',
                            'sipas/account/scope/1',
                            'sipas/account/notification',
                            'sipas/account/notification/mobile',
                            'sipas/account/newmail',
                            'sipas/account/wakil',
                            'sipas/account/unit')), 

    array('session',    0, array(
                            'sipas/account/login/token',
                            'sipas/account/login',
                            'sipas/account/logout',
                            'sipas/account/info/logintime',
                            'sipas/account/info/user',
                            'sipas/account/info/profile',
                            'sipas/account/info/rules',
                            'sipas/account/info/session')), 

    //addon
    //akses
    array('hakakses',   1, array(
                            'sipas/akses',
                            'sipas/akses/index',
                            'sipas/akses/read')),

    array('hakakses_update',    2, array('sipas/akses/update')), 
    //aksi
    array('aksi_insert',    2, array('sipas/aksi/create')),
    array('aksi_update',    2, array('sipas/aksi/update')),
    array('aksi_delete',    2, array('sipas/aksi/destroy')),

    array('aksi',   1, array(
                        'sipas/aksi',
                        'sipas/aksi/index',
                        'sipas/aksi/read',
                        'sipas/aksi/aktif',
                        'sipas/aksi/nonaktif')),
    //akun
    array('staf_insert',    2, array('sipas/akun/create')),
    array('staf_update',    2, array('sipas/akun/update')),
    array('staf_delete',    2, array('sipas/akun/destroy')),
    array('staf',   1, array(
                        'sipas/akun',
                        'sipas/akun/index',
                        'sipas/akun/read')), 
    //api
    array('api_info',   0, array('sipas/api',
                            'sipas/api/index',
							'sipas/api/controllers',
                            'sipas/api/info')), 

    //arsip 
    array('bebas',  2, array('sipas/arsip/create')), 
    array('bebas',  2, array('sipas/arsip/update')), 
    array('bebas',  2, array('sipas/arsip/destroy')), 
    array('bebas',  0, array('sipas/arsip/link')),
    array('bebas',  1, array('sipas/arsip',
                         'sipas/arsip/index',
                         'sipas/arsip/read',
                         'sipas/arsip/hidup',
                         'sipas/arsip/bagi',
                         'sipas/arsip/umum',
                         'sipas/arsip/link',
                         'sipas/arsip/arsip_auth',
                         'sipas/arsip/arsip_duplicate',
                         'sipas/arsip/report',
                         'sipas/arsip/report_rekap',
                         'sipas/arsip/generateField')),

    //asset
    array('asset',  1, array('sipas/asset/css',
                        'sipas/asset/img',
                        'sipas/asset/js',
						'sipas/asset/index',
						'sipas/asset/inst_logo',
						'sipas/asset/testurl',
                        'sipas/asset')),

    //backuprestore
    array('backuprestore',  2, array(
                                'sipas/backup',
                                'sipas/backup/index',
                                'sipas/backup/read',
                                'sipas/backup/create',
                                'sipas/backup/update',
                                'sipas/restore/create',
                                'sipas/restore',
                                'sipas/restore/index',
                                'sipas/restore/read',
                                'sipas/restore/download')),

    //bank
    array('bank',   2, array('sipas/bank',
                        'sipas/bank/index',
                        'sipas/bank/read',
                        'sipas/bank/read/0', 
                        'sipas/bank/read/1',
                        'sipas/bank/read/2',
                        'sipas/bank/read/3',
                        'sipas/bank/read/4',
                        'sipas/bank/aktif/0',
                        'sipas/bank/aktif/1',
                        'sipas/bank/aktif/2',
                        'sipas/bank/aktif/3',
                        'sipas/bank/aktif/4',
                        'sipas/bank/nonaktif/0',
                        'sipas/bank/nonaktif/1',
                        'sipas/bank/nonaktif/2',
                        'sipas/bank/nonaktif/3',
                        'sipas/bank/nonaktif/4')),
    //beranda
    array('beranda',    1, array('sipas/beranda',
                            'sipas/beranda/index',
                            'sipas/beranda/surat_masuk',
                            'sipas/beranda/suratcount',
                            'sipas/beranda/suratcount/chart')),

    /* not found
    //dasbor
    array('rekap_dashboard',    1, array(
                                        'sipas/dasbor',
                                        'sipas/dasbor/index',
                                        'sipas/dasbor/surat_masuk',
                                        'sipas/dasbor/surat_keluar',
                                        'sipas/dasbor/disposisi_masuk',
                                        'sipas/dasbor/chart',
                                        'sipas/dasbor/get_dashboard')), */
    //disposisi
    array('disposisi',  1, array('sipas/disposisi/create')),
    array('disposisi',  1, array('sipas/disposisi/update')),
    array('disposisi',  1, array(
                            'sipas/disposisi',
                            'sipas/disposisi/index',
                            'sipas/disposisi/read',
                            'sipas/disposisi/riwayat',
                            'sipas/disposisi/report',
                            'sipas/disposisi/next',
                            'sipas/disposisi/baca_aksi',
                            'sipas/disposisi/next/code')), 
    //disposisi batal
    array('disposisi_batal_semua',  2, array('sipas/disposisi/cabut_all')),
    array('disposisi_batal_blm_baca',  2, array('sipas/disposisi/cabut_unread')),
    array('disposisi_batal_turunan',  2, array('sipas/disposisi/cabut_trace')),

    //disposisi_masuk
    array('disposisi',  1, array('sipas/disposisi_masuk/update')), 
    array('disposisi',  1, array('sipas/disposisi_masuk',
                            'sipas/disposisi_masuk/index',
                            'sipas/disposisi_masuk/read',
							'sipas/disposisi_masuk/masuk',
                            'sipas/disposisi_masuk/report',
							'sipas/disposisi_masuk/trace_root',
							'sipas/disposisi_masuk/get_disposisi_pack',
                            'sipas/disposisi_masuk/isexist_session',
                            'sipas/disposisi_masuk/isexist',
                            'sipas/disposisi_masuk/trace_root',
                            'sipas/disposisi_masuk/get_disposisi_pack',
                            'sipas/disposisi_masuk/tembusan_isexist')), 

    //disposisi_masuk_log
    array('disposisi',  1, array('sipas/disposisi_masuk_log/create')), 
    array('disposisi',  1, array('sipas/disposisi_masuk_log',
                            'sipas/disposisi_masuk_log/index',
                            'sipas/disposisi_masuk_log/generate_id',
                            'sipas/disposisi_masuk_log/respon',
                            'sipas/disposisi_masuk_log/read')), 

    //disposisi_referensi
    array('disposisi',  1, array('sipas/disposisi_referensi',
                            'sipas/disposisi_referensi/index',
                            'sipas/disposisi_referensi/read')), 

    //disposisi_riwayat
    array('disposisi',  1, array('sipas/disposisi_riwayat',
                            'sipas/disposisi_riwayat/index',
                            'sipas/disposisi_riwayat/read')), 

    //dokumen => not found
    array('dokumen',    1, array('sipas/dokumen/create',
                            'sipas/dokumen/create/dokumen',
                            'sipas/dokumen/create/link',
                            'sipas/dokumen/create/sdoc',
                            'sipas/dokumen/generateTemplate')), 
    array('dokumen',    1, array('sipas/dokumen/update',
                            'sipas/dokumen/update/dokumen',
                            'sipas/dokumen/update/link',
                            'sipas/dokumen/update/sdoc',
                            'sipas/dokumen/update/rename')), 
    array('dokumen',    1, array('sipas/dokumen/create_scan')), 
    array('dokumen',    1, array('sipas/dokumen/update_scan')), 
    array('dokumen',    1, array('sipas/dokumen/destroy',
                            'sipas/dokumen/destroy/dokumen',
                            'sipas/dokumen/destroy/link',
                            'sipas/dokumen/destroy/sdoc')), 

    array('dokumen',    0, array('sipas/dokumen/preview')), 
    array('dokumen',    1, array('sipas/dokumen',
                            'sipas/dokumen/index',
                            'sipas/dokumen/read',
                            'sipas/dokumen/view',
                            'sipas/dokumen/view_pdf',
                            'sipas/dokumen/download',
                            'sipas/dokumen/dokumen',
                            'sipas/dokumen/link',
                            'sipas/dokumen/sdoc',
                            'sipas/dokumen/transporter',
                            'sipas/dokumen/transporter_reupload',
                            'sipas/dokumen/transporter_sdoc',
                            'sipas/dokumen/printSdoc',
                            'sipas/dokumen/isMaxs',
                            'sipas/dokumen/checkqrcode',
                            'sipas/dokumen/duplicate')), 
    //dokumen_log
    array('dokumen',    1, array('sipas/dokumen_log',
                            'sipas/dokumen_log/index',
                            'sipas/dokumen_log/read',
                            'sipas/dokumen_log/read/trace',
                            'sipas/dokumen_log/report')),

    //ekspedisi
    array('ekspedisi_insert',   2, array('sipas/ekspedisi/create')),
    array('ekspedisi_update',   2, array('sipas/ekspedisi/update')),
    array('ekspedisi_delete',   2, array('sipas/ekspedisi/destroy')),
    array('ekspedisi',  1, array('sipas/ekspedisi',
                            'sipas/ekspedisi/index',
                            'sipas/ekspedisi/read',
                            'sipas/ekspedisi/aktif',
                            'sipas/ekspedisi/nonaktif',
                            'sipas/ekspedisi/combo')),

    //email => not found
    array('email_queue',    1, array(
                                'sipas/email/send_queue',
                                'sipas/email/retry_queue')),
    array('email_queue',    1, array(
                                'sipas/email/index',
                                'sipas/email/getEmailConfig',
                                'sipas/email/test')),

    //help => not found
    array('support',    1, array(
                            'sipas/help',
                            'sipas/help/index',
                            'sipas/help/help')), 

    //jabatan
    array('jabatan_insert', 2, array('sipas/jabatan/create')),
    array('jabatan_update', 2, array('sipas/jabatan/update')),
    array('jabatan_delete', 2, array('sipas/jabatan/destroy')),
    array('jabatan',        1, array(
                                'sipas/jabatan',
                                'sipas/jabatan/index',
                                'sipas/jabatan/read',
                                'sipas/jabatan/read/tree',
                                'sipas/jabatan/aktif',
                                'sipas/jabatan/aktif/tree',
                                'sipas/jabatan/nonaktif',
                                'sipas/jabatan/nonaktif/tree')), 

    //jenis
    array('jenis_insert',   2, array('sipas/jenis/create')),
    array('jenis_update',   2, array('sipas/jenis/update')),
    array('jenis_delete',   2, array('sipas/jenis/destroy')),
    array('jenis',          1, array('sipas/jenis',
                                'sipas/jenis/index',
                                'sipas/jenis/read',
                                'sipas/jenis/aktif',
        						'sipas/jenis/is_useawal',
                                'sipas/jenis/perunit_aktif',
                                'sipas/jenis/perunit',
                                'sipas/jenis/jenis_perunit',
                                'sipas/jenis/nonaktif')),
    
    //jenis unit
    array('jenis_unit', 1, array('sipas/jenis_unit/read',
							'sipas/jenis_unit/index',
                            'sipas/jenis_unit/destroy')), 
    array('jenis_unit_insert',  2, array(
                                    'sipas/jenis_unit/create',
                                    'sipas/jenis_unit/update')),

    //kelas
    array('kelas_insert',   2, array('sipas/kelas/create')),
    array('kelas_update',   2, array('sipas/kelas/update')),
    array('kelas_delete',   2, array('sipas/kelas/destroy')),
    array('kelas',  1, array('sipas/kelas',
                        'sipas/kelas/index',
                        'sipas/kelas/read',
                        'sipas/kelas/read/tree',
                        'sipas/kelas/readJenis',
						'sipas/kelas/combo_aktif',
                        'sipas/kelas/aktif',
                        'sipas/kelas/aktif/tree',
                        'sipas/kelas/nonaktif',
                        'sipas/kelas/nonaktif/tree')),

    //klise
    array('template_insert',    2, array('sipas/klise/create')),
    array('template_update',    2, array('sipas/klise/update')),
    array('template_delete',    2, array('sipas/klise/destroy')),
    array('surat_template',     1, array(
                                    'sipas/klise',
                                    'sipas/klise/transporter',
                                    'sipas/klise/index',
                                    'sipas/klise/read',
                                    'sipas/klise/aktif',
                                    'sipas/klise/nonaktif',
                                    'sipas/klise/template',
                                    'sipas/klise/preview',
                                    'sipas/klise/download')),

    //klise_kelompok
    array('surat_template',     2, array('sipas/klise_kelompok/create')),
    array('surat_template',     2, array('sipas/klise_kelompok/update')),
    array('surat_template',     2, array('sipas/klise_kelompok/destroy')),
    array('surat_template',     1, array(
                                    'sipas/klise_kelompok',
                                    'sipas/klise_kelompok/index',                                     
                                    'sipas/klise_kelompok/read')), 
    //kontak
    array('kontak_insert',      2, array('sipas/kontak/create')),
    array('kontak_update',      2, array('sipas/kontak/update')),
    array('kontak_delete',      2, array('sipas/kontak/destroy')),
    array('kontak',             1, array(
                                    'sipas/kontak',
                                    'sipas/kontak/index',
                                    'sipas/kontak/read',                                     
                                    'sipas/kontak/aktif',                                     
                                    'sipas/kontak/nonaktif')), 

    /*koreksi tidak punya rule*/

    array('koreksi_ubah',       2, array(
                                    'sipas/surat_keluar/update', //ubah surat dari koreksi
                                    'sipas/surat_ikeluar/update')), //ubah surat dari koreksi

    //koreksi
    array('koreksi',    1, array('sipas/koreksi/update')),
    array('koreksi',    1, array('sipas/koreksi',
                                    'sipas/koreksi/index',
                                    'sipas/koreksi/read')), 
    //koreksi_masuk
    array('koreksi',    1, array('sipas/koreksi_masuk/update')),
    array('koreksi',    1, array('sipas/koreksi_masuk/updateKoreksi')),
    array('koreksi',    1, array('sipas/koreksi_masuk',
                            'sipas/koreksi_masuk/index',
                            'sipas/koreksi_masuk/read',
                            'sipas/koreksi_masuk/riwayat',
                            'sipas/koreksi_masuk/report',
                            'sipas/koreksi_masuk/penerima',
                            'sipas/koreksi_masuk/getIndex',
                            'sipas/koreksi_masuk/traceKoreksi',
                            'sipas/koreksi_masuk/traceIdKoreksi')),

    /* korespondensi dibagi per model surat, there's no korespondensi_surat */
    //korespondensi
    array('korespondensi_surat_eksternal',  2, array(
                                                'sipas/korespondensi/eksternal',
                                                'sipas/korespondensi/eksternal/list')),

    array('korespondensi_surat_internal',  2, array(
                                                'sipas/korespondensi/internal',
                                                'sipas/korespondensi/internal/list')),

    array('korespondensi_surat',    1, array('sipas/korespondensi/create')),
    array('korespondensi_surat',    1, array(
                                        'sipas/korespondensi',
                                        'sipas/korespondensi/index',                                         
                                        'sipas/korespondensi/read',                                         
                                        'sipas/korespondensi/read/list',                                         
                                        'sipas/korespondensi/report',                                         
                                        'sipas/korespondensi/report/all',                                         
                                        'sipas/korespondensi/report_eksternal/all',
                                        'sipas/korespondensi/report_internal/all',
                                        'sipas/korespondensi/reSetting',
                                        'sipas/korespondensi/perihal',
                                        'sipas/korespondensi/perihal_internal')),
    
    //lokasi
    array('lokasi_insert',  2, array('sipas/lokasi/create')),
    array('lokasi_update',  2, array('sipas/lokasi/update')),
    array('lokasi_delete',  2, array('sipas/lokasi/destroy')),
    array('lokasi',         1, array(
                                'sipas/lokasi',
                                'sipas/lokasi/index',
                                'sipas/lokasi/read',
                                'sipas/lokasi/aktif',
                                'sipas/lokasi/nonaktif')),

    //media
    array('media_insert',   2, array('sipas/media/create')),
    array('media_update',   2, array('sipas/media/update')),
    array('media_delete',   2, array('sipas/media/destroy')),
    array('media',          1, array(
                                'sipas/media',
                                'sipas/media/index',
                                'sipas/media/read',
                                'sipas/media/aktif',
                                'sipas/media/nonaktif')),

    //mobile => role not found
    array('mobile',     1, array(
                            'sipas/mobile',
                            'sipas/mobile/index',
                            'sipas/mobile/info',
                            'sipas/mobile/download_manualbook')),

    //notifikasi => role not found
    array('notifikasi',     1, array('sipas/notifikasi/create')),
    array('notifikasi',     1, array('sipas/notifikasi/update')),
    array('notifikasi',     1, array(
                                'sipas/notifikasi',
                                'sipas/notifikasi/index',
                                'sipas/notifikasi/mobile',
                                'sipas/notifikasi/notifikasi_test',
                                'sipas/notifikasi/notifikasi_test/email',
                                'sipas/notifikasi/notifikasi_test/sms',
                                'sipas/notifikasi/getEmailConfig',
                                'sipas/notifikasi/notifikasi_queue',
                                'sipas/notifikasi/notifikasi_queue/email',
                                'sipas/notifikasi/notifikasi_queue/sms',
                                'sipas/notifikasi/notifikasi_retry',
                                'sipas/notifikasi/notifikasi_retry/email',
                                'sipas/notifikasi/notifikasi_retry/sms')), 
    
    //pelaporan
    array('pelaporan',      1, array(
                                'sipas/pelaporan',
                                'sipas/pelaporan/index',
                                'sipas/pelaporan/chart_surat_masuk',
                                'sipas/pelaporan/chart_surat_tindaklanjut',
                                'sipas/pelaporan/chart_surat_topurgent',
                                'sipas/pelaporan/rekap_surat_masuk',
                                'sipas/pelaporan/rekap_surat_keluar',
                                'sipas/pelaporan/rekap_retensi',
                                'sipas/pelaporan/chart_eksternal_bulanan',
                                'sipas/pelaporan/chart_eksternal_harian',
                                'sipas/pelaporan/dashboard',
                                'sipas/pelaporan/get_last_date',
                                'sipas/pelaporan/get_week',
                                'sipas/pelaporan/get_date_range')),
    //pelaporan_sla
    array('pelaporan_sla',      1, array(
                                'sipas/pelaporan_sla',
                                'sipas/pelaporan_sla/report_sla_request',
                                'sipas/pelaporan_sla/report_sla_request/date',
                                'sipas/pelaporan_sla/report_sla_request/daterange',
                                'sipas/pelaporan_sla/report_sla_request/beforedate',
                                'sipas/pelaporan_sla/report_sla_request/afterdate',
                                'sipas/pelaporan_sla/report_sla_request/month',
                                'sipas/pelaporan_sla/report_sla_request/year',
                                'sipas/pelaporan_sla/report_sla_proses',
                                'sipas/pelaporan_sla/report_sla_selesai',
                                'sipas/pelaporan_sla/report_sla_selesai/date',
                                'sipas/pelaporan_sla/report_sla_selesai/daterange',
                                'sipas/pelaporan_sla/report_sla_selesai/beforedate',
                                'sipas/pelaporan_sla/report_sla_selesai/afterdate',
                                'sipas/pelaporan_sla/report_sla_selesai/month',
                                'sipas/pelaporan_sla/report_sla_selesai/year',
                                'sipas/pelaporan_sla/report_sla_tolak',
                                'sipas/pelaporan_sla/report_sla_tolak/date',
                                'sipas/pelaporan_sla/report_sla_tolak/daterange',
                                'sipas/pelaporan_sla/report_sla_tolak/beforedate',
                                'sipas/pelaporan_sla/report_sla_tolak/afterdate',
                                'sipas/pelaporan_sla/report_sla_tolak/month',
                                'sipas/pelaporan_sla/report_sla_tolak/year',
                                'sipas/pelaporan_sla/report_sla_kumulatif',
                                'sipas/pelaporan_sla/report_sla_kumulatif/date',
                                'sipas/pelaporan_sla/report_sla_kumulatif/daterange',
                                'sipas/pelaporan_sla/report_sla_kumulatif/beforedate',
                                'sipas/pelaporan_sla/report_sla_kumulatif/afterdate',
                                'sipas/pelaporan_sla/report_sla_kumulatif/month',
                                'sipas/pelaporan_sla/report_sla_kumulatif/year',
                                'sipas/pelaporan_sla/get_last_date',
                                'sipas/pelaporan_sla/get_week',
                                'sipas/pelaporan_sla/next_date',
                                'sipas/pelaporan_sla/get_date_range')),
    //pengaturan
    array('pengaturan_sistem',  1, array(
                                    'sipas/pengaturan',
                                    'sipas/pengaturan/index',
                                    'sipas/pengaturan/get_setting',
                                    'sipas/pengaturan/set_setting',
                                    'sipas/pengaturan/get_image',
                                    'sipas/pengaturan/get_image_logo',
                                    'sipas/pengaturan/get_image/template_header_leftlogo',
                                    'sipas/pengaturan/get_image/template_header_rightlogo',
                                    'sipas/pengaturan/set_image',
                                    'sipas/pengaturan/set_image/template_header_logo1',
                                    'sipas/pengaturan/set_image/template_header_logo2',
                                    'sipas/pengaturan/set_image/template_header_logo3',
                                    'sipas/pengaturan/set_image/template_header_logo4',
                                    'sipas/pengaturan/set_image/template_header_logo5',
                                    'sipas/pengaturan/get_image/template_header_logo1',
                                    'sipas/pengaturan/get_image/template_header_logo2',
                                    'sipas/pengaturan/get_image/template_header_logo3',
                                    'sipas/pengaturan/get_image/template_header_logo4',
                                    'sipas/pengaturan/get_image/template_header_logo5',
                                    'sipas/pengaturan/get_surat_penomoran_legenda',
                                    'sipas/pengaturan/getSettingByCode')),

    //peran
    array('hakakses_insert',    2, array('sipas/peran/create')),
    array('hakakses_update',    2, array('sipas/peran/update')),
    array('hakakses_delete',    2, array('sipas/peran/destroy')),
    array('hakakses',           1, array(
                                    'sipas/peran',
                                    'sipas/peran/index',
                                    'sipas/peran/generate_id',
                                    'sipas/peran/read',
                                    'sipas/peran/aktif',
                                    'sipas/peran/nonaktif')),

    //perintah
    array('perintah_insert',    2, array('sipas/perintah/create')),
    array('perintah_update',    2, array('sipas/perintah/update')),
    array('perintah_delete',    2, array('sipas/perintah/destroy')),
    array('perintah',           1, array(
                                    'sipas/perintah',
                                    'sipas/perintah/index',
                                    'sipas/perintah/read',
                                    'sipas/perintah/aktif',
                                    'sipas/perintah/nonaktif')),

    //prioritas
    array('prioritas_insert',   2, array('sipas/prioritas/create')),
    array('prioritas_update',   2, array('sipas/prioritas/update')),
    array('prioritas_delete',   2, array('sipas/prioritas/destroy')),
    array('prioritas',          1, array(
                                    'sipas/prioritas',
                                    'sipas/prioritas/index',
                                    'sipas/prioritas/read',
                                    'sipas/prioritas/getHari',
                                    'sipas/prioritas/aktif',
                                    'sipas/prioritas/nonaktif')),

    //properti => role not found
    array('properti',   1, array(
                            'sipas/properti',
                            'sipas/properti/index',
                            'sipas/properti/read')), 

    //properti_log => role not found
    array('properti',   1, array(
                            'sipas/properti_log',
                            'sipas/properti_log/index',
                            'sipas/properti_log/read')),
    //report
    array('pelaporan',  1, array(
                            'sipas/report',
                            'sipas/report/index',
                            'sipas/report/generate_report',
                            'sipas/report/generate_report/pdf',
                            'sipas/report/generate_report/excel',
                            'sipas/report/generate_report/html')),

    //retensi
    array('retensi_insert',     2, array('sipas/retensi/create')),
    array('retensi_update',     2, array('sipas/retensi/update')),
    array('retensi_delete',     2, array('sipas/retensi/destroy')),
    array('retensi',            1, array(
                                    'sipas/retensi',
                                    'sipas/retensi/index',
                                    'sipas/retensi/read',
                                    'sipas/retensi/aktif',
                                    'sipas/retensi/nonaktif')),

    //sifat
    array('sifat_insert',   2, array('sipas/sifat/create')),
    array('sifat_update',   2, array('sipas/sifat/update')),
    array('sifat_delete',   2, array('sipas/sifat/destroy')),
    array('sifat',          1, array(
                                'sipas/sifat',
                                'sipas/sifat/readrahasia',
                                'sipas/sifat/index',
                                'sipas/sifat/read',
                                'sipas/sifat/aktif',
                                'sipas/sifat/aktif/tree',
                                'sipas/sifat/nonaktif',
                                'sipas/sifat/nonaktif/tree')),

    //sla
    array('sla_insert',     2, array('sipas/sla/create')),
    array('sla_update',     2, array('sipas/sla/update')),
    array('sla_delete',     2, array('sipas/sla/destroy')),
    array('sla',            1, array(
                                'sipas/sla',
                                'sipas/sla/index',
                                'sipas/sla/read',
                                'sipas/sla/aktif',
                                'sipas/sla/nonaktif')),

    //sla_kuis
    array('sla',   1, array('sipas/sla_kuis/create')),
    array('sla',   1, array('sipas/sla_kuis/update')),
    array('sla',   1, array('sipas/sla_kuis/destroy')),
    array('sla',   1, array(
                        'sipas/sla_kuis',
                        'sipas/sla_kuis/index',
                        'sipas/sla_kuis/read')), 

    //sla_rumus
    array('sla',    1, array('sipas/sla_rumus/create')),
    array('sla',    1, array('sipas/sla_rumus/update')),
    array('sla',    1, array('sipas/sla_rumus/destroy')),
    array('sla',    1, array(
                        'sipas/sla_rumus',
                        'sipas/sla_rumus/index',
                        'sipas/sla_rumus/read')),

    //sla_ujian
    array('sla',    1, array('sipas/sla_ujian/create')),
    array('sla',    1, array('sipas/sla_ujian/update')),
    array('sla',    1, array('sipas/sla_ujian/destroy')),
    array('sla',    1, array(
                        'sipas/sla_ujian',
                        'sipas/sla_ujian/index',
                        'sipas/sla_ujian/read')), 

    //sla_unit
    array('sla_unit_insert',    2, array('sipas/sla_unit/create')),
    array('sla_unit',   1, array('sipas/sla_unit/update')),
    array('sla_unit',   1, array('sipas/sla_unit/destroy')),
    array('sla_unit',   1, array(
                            'sipas/sla_unit',
                            'sipas/sla_unit/index',
                            'sipas/sla_unit/read',
                            'sipas/sla_unit/default')),

    //sms_phones => role not found
    array('sms_phones',     1, array(
                                'sipas/sms_phones',
                                'sipas/sms_phones/index',
                                'sipas/sms_phones/status',
                                'sipas/sms_phones/check_status')), 

    //sms_test => role not found
    array('sms_test',       1, array(
                                'sipas/sms_test',
                                'sipas/sms_test/index',
                                'sipas/sms_test/send_sms')), 

    //staf
    array('staf_insert',    2, array('sipas/staf/create')),
    array('staf_update',    2, array('sipas/staf/update')),
    array('staf_delete',    2, array('sipas/staf/destroy')),
    array('staf',           0, array(
    							'sipas/staf/get_image',
                                'sipas/staf/get_image/foto',
                                'sipas/staf/get_image/ttd',
                                'sipas/staf/get_image_logo')),

    array('staf',           1, array(
                                'sipas/staf',
                                'sipas/staf/index',
                                'sipas/staf/read',
                                'sipas/staf/aktif',
                                'sipas/staf/nonaktif',
                                'sipas/staf/penerima',
                                'sipas/staf/penerima/recent',
                                'sipas/staf/penerima/staf',
                                'sipas/staf/penerima/unitkerja',
                                'sipas/staf/penerima/available',
                                'sipas/staf/penerima/jabatan',
                                'sipas/staf/url_image',
                                'sipas/staf/url_image/foto',
                                'sipas/staf/url_image/ttd',
                                'sipas/staf/set_image',
                                'sipas/staf/set_image/foto',
                                'sipas/staf/set_image/ttd',
                                'sipas/staf/import_staf',
                                'sipas/staf/import_read',
                                'sipas/staf/randomize',
                                'sipas/staf/transporter',
                                'sipas/staf/pegawai_jumlah_report',
                                'sipas/staf/pegawai_akun_report',
                                'sipas/staf/penerima_disposisi',
                                'sipas/staf/penerima_disposisi/available', 
                                'sipas/staf/penerima_disposisi/unitkerja', 
                                'sipas/staf/penerima_disposisi/recent',
                                'sipas/staf/penerima_disposisi/staf',
                                'sipas/staf/penerima_disposisi/jabatan',
                                'sipas/staf/penerima_disposisi_custom',
                                'sipas/staf/penerima_disposisi_custom/recent',
                                'sipas/staf/penerima_disposisi_custom/available',
                                'sipas/staf/penerima_disposisi_custom/staf')), 

    //staf_tim
    array('staf_tim_insert',    2, array('sipas/staf_tim/create')),
    array('staf_tim_update',    2, array('sipas/staf_tim/update')),
    array('staf_tim_delete',    2, array('sipas/staf_tim/destroy')),
    array('staf_tim',           1, array(
                                    'sipas/staf_tim',
                                    'sipas/staf_tim/index',
                                    'sipas/staf_tim/read')),

    //staf_tim_anggota
    array('staf_tim',   2, array('sipas/staf_tim_anggota/create')),
    array('staf_tim',   2, array('sipas/staf_tim_anggota/update')),
    array('staf_tim',   2, array('sipas/staf_tim_anggota/destroy')),
    array('staf_tim',   1, array(
                            'sipas/staf_tim_anggota',
                            'sipas/staf_tim_anggota/index',
                            'sipas/staf_tim_anggota/read',
                            'sipas/staf_tim_anggota/read_group',
                            'sipas/staf_tim_anggota/read_disposisi',
                            'sipas/staf_tim_anggota/readKelompok')),

    //staf_wakil
    array('staf_wakil_monitoring_save',     2, array('sipas/staf_wakil/create')),
    array('staf_wakil_monitoring',          2, array('sipas/staf_wakil/update')),
    array('staf_wakil_monitoring',          2, array('sipas/staf_wakil/destroy')),
    array('staf_wakil_monitoring',          1, array(
                                                'sipas/staf_wakil',
                                                'sipas/staf_wakil/index',
                                                'sipas/staf_wakil/read',
                                                'sipas/staf_wakil/atasan')), 

    //staf_wakil_monitoring
    array('staf_wakil_monitoring',  1, array(
                                        'sipas/staf_wakil_monitoring',
                                        'sipas/staf_wakil_monitoring/index',
                                        'sipas/staf_wakil_monitoring/read',
                                        'sipas/staf_wakil_monitoring/read/masuk',
                                        'sipas/staf_wakil_monitoring/read/disposisi',
                                        'sipas/staf_wakil_monitoring/read/riwayat',
                                        'sipas/staf_wakil_monitoring/read/riwayat_aktif',
                                        'sipas/staf_wakil_monitoring/read/riwayat_nonaktif',
                                        'sipas/staf_wakil_monitoring/read/koreksi',
                                        'sipas/staf_wakil_monitoring/monitored_staf')),

    //staf_wakil_asisten
    array('staf_wakil',     1, array(
                                'sipas/staf_wakil_asisten',
                                'sipas/staf_wakil_asisten/index',
                                'sipas/staf_wakil_asisten/read',
                                'sipas/staf_wakil_asisten/read/available')), 

    //support => role not found
    array('support',    1, array(
                            'sipas/support',
                            'sipas/support/doc')), 

    //surat lib nomor
    array('surat',      1, array(
                                'sipas/surat_libnomor/create',
                                'sipas/surat_libnomor/read',
                                'sipas/surat_libnomor/update',
                                'sipas/surat_libnomor/destroy')),

    //surat => role not found, punya role msg2 sesuai model
    array('surat',      1, array('sipas/surat/create')),
    array('surat',      1, array('sipas/surat/createImport')),
    array('surat',      1, array('sipas/surat/simpanLokasi')),
    array('surat',      1, array('sipas/surat/update')),
    array('surat',      1, array('sipas/surat/destroy')),
    array('surat',      1, array(
                            'sipas/surat',
                            'sipas/surat/index',
                            'sipas/surat/read',
                            'sipas/surat/check_nomor',
                            'sipas/surat/next',
                            'sipas/surat/next/nomor',
                            'sipas/surat/next/agenda',
                            'sipas/surat/next/registrasi',
                            'sipas/surat/resi',
                            'sipas/surat/resi/surat',
                            'sipas/surat/transporter',
                            'sipas/surat/report',
                            'sipas/surat/report_eksternal',
                            'sipas/surat/report_internal',
                            'sipas/surat/report_jenis',
                            'sipas/surat/grafik_bulanan',
                            'sipas/surat/printApproval',
                            'sipas/surat/checkqrcode',
                            'sipas/surat/generateNomor')), 

    //surat_ekspedisi
    array('masuk_ekspedisi',    1, array(
                                    'sipas/surat_ekspedisi',
                                    'sipas/surat_ekspedisi/index',
                                    'sipas/surat_ekspedisi/linier_ekspedisi',
                                    'sipas/surat_ekspedisi/read',
                                    'sipas/surat_ekspedisi/read/trace',
                                    'sipas/surat_ekspedisi/read/tree',
                                    'sipas/surat_ekspedisi/report',
                                    'sipas/surat_ekspedisi/trace_root',
                                    'sipas/surat_ekspedisi/get_disposisi_pack')),

    //surat_ikeluar
    array('surat_internal_keluar_insert',   1, array('sipas/surat_ikeluar/create')),
    array('surat_internal_keluar_update',   1, array('sipas/surat_ikeluar/update')),
    array('surat_internal_keluar_delete',   1, array('sipas/surat_ikeluar/destroy')),
    array('surat_internal_keluar',          1, array(
                                                'sipas/surat_ikeluar',
                                                'sipas/surat_ikeluar/index',
                                                'sipas/surat_ikeluar/read',
                                                'sipas/surat_ikeluar/draft',
                                                'sipas/surat_ikeluar/setuju',
                                                'sipas/surat_ikeluar/setuju_list',
                                                'sipas/surat_ikeluar/dlm_setuju',
                                                'sipas/surat_ikeluar/revisi',
                                                'sipas/surat_ikeluar/blm_nomor',
                                                'sipas/surat_ikeluar/blm_terima',
                                                'sipas/surat_ikeluar/terima',
                                                'sipas/surat_ikeluar/tolak',
                                                'sipas/surat_ikeluar/resend',
                                                'sipas/surat_ikeluar/setuju',
                                                'sipas/surat_ikeluar/disposisi',
                                                'sipas/surat_ikeluar/scope',
                                                'sipas/surat_ikeluar/internal_report',
                                                'sipas/surat_ikeluar/internal_report_semua',
                                                'sipas/surat_ikeluar/internal_report_kewenangan',
                                                'sipas/surat_ikeluar/internal_report_unprocessed',
                                                'sipas/surat_ikeluar/internal_report_blmsetuju',
                                                'sipas/surat_ikeluar/internal_report_blmsetuju_semua',
                                                'sipas/surat_ikeluar/internal_report_blmsetuju_kewenangan',
                                                'sipas/surat_ikeluar/report_rekap',
                                                'sipas/surat_ikeluar/report_retensi',
                                                'sipas/surat_ikeluar/report_retensi_semua',
                                                'sipas/surat_ikeluar/next',
                                                'sipas/surat_ikeluar/next/agenda',
                                                'sipas/surat_ikeluar/next/nomor',
                                                'sipas/surat_ikeluar/cek_rule',
                                                'sipas/surat_ikeluar/aktif',
                                                'sipas/surat_ikeluar/referensi_nomor',
                                                'sipas/surat_ikeluar/nonaktif',
                                                'sipas/surat_ikeluar/transport_imasuk')),
    //surat_imasuk
    array('surat_internal_masuk_insert',    2, array('sipas/surat_imasuk/create')),
    array('surat_internal_masuk',           1, array('sipas/surat_imasuk/update')),
    array('surat_internal_masuk',           1, array('sipas/surat_imasuk/destroy')),
    array('surat_internal_masuk',           1, array(
                                                'sipas/surat_imasuk',
                                                'sipas/surat_imasuk/index',
                                                'sipas/surat_imasuk/read',
                                                'sipas/surat_imasuk/draft',
                                                'sipas/surat_imasuk/unapproved',
                                                'sipas/surat_imasuk/pending',
                                                'sipas/surat_imasuk/terima',
                                                'sipas/surat_imasuk/tolak',
                                                'sipas/surat_imasuk/blm_distribusi',
                                                'sipas/surat_imasuk/distribusi',
                                                'sipas/surat_imasuk/approved',
                                                'sipas/surat_imasuk/aktif',
                                                'sipas/surat_imasuk/aktif_list',
                                                'sipas/surat_imasuk/aktif7',
                                                'sipas/surat_imasuk/aktif3',
                                                'sipas/surat_imasuk/aktif1',
                                                'sipas/surat_imasuk/nonaktif',
                                                'sipas/surat_imasuk/internal_report',
                                                'sipas/surat_imasuk/internal_report_semua',
                                                'sipas/surat_imasuk/internal_report_kewenangan',
                                                'sipas/surat_imasuk/internal_report_tunda',
                                                'sipas/surat_imasuk/internal_report_tunda_semua',
                                                'sipas/surat_imasuk/internal_report_tunda_kewenangan',
                                                'sipas/surat_imasuk/report_rekap',
                                                'sipas/surat_imasuk/next',
                                                'sipas/surat_imasuk/next/agenda',
                                                'sipas/surat_imasuk/next/nomor',
                                                'sipas/surat_imasuk/get_latest_penyetuju',
                                                'sipas/surat_imasuk/internal_report_tolak',
                                                'sipas/surat_imasuk/internal_report_tolak_semua',
                                                'sipas/surat_imasuk/internal_report_tolak_kewenangan')),
    
    //surat_keluar
    array('keluar_insert',      2, array('sipas/surat_keluar/create')),
    array('keluar_update',      2, array('sipas/surat_keluar/update')),
    array('keluar_delete',      2, array('sipas/surat_keluar/destroy')),
    array('keluar',             1, array(
                                    'sipas/surat_keluar',
                                    'sipas/surat_keluar/index',
                                    'sipas/surat_keluar/read',
                                    'sipas/surat_keluar/draft',
                                    'sipas/surat_keluar/dlm_setuju',
                                    'sipas/surat_keluar/setuju',
                                    'sipas/surat_keluar/setuju_list',
                                    'sipas/surat_keluar/revisi',
                                    'sipas/surat_keluar/blm_nomor',
                                    'sipas/surat_keluar/blm_ekspedisi',
                                    'sipas/surat_keluar/ekspedisi',
                                    'sipas/surat_keluar/aktif',
                                    'sipas/surat_keluar/nonaktif',
                                    'sipas/surat_keluar/next',
                                    'sipas/surat_keluar/next/agenda',
                                    'sipas/surat_keluar/next/kode',
                                    'sipas/surat_keluar/report',
                                    'sipas/surat_keluar/report_semua',
                                    'sipas/surat_keluar/report_kewenangan',
                                    'sipas/surat_keluar/report_blmdisetujui',
                                    'sipas/surat_keluar/report_rekap',
                                    'sipas/surat_keluar/report_backdate',
                                    'sipas/surat_keluar/getBalas',
                                    'sipas/surat_keluar/report_retensi',
                                    'sipas/surat_keluar/report_retensi_semua',
                                    'sipas/surat_keluar/referensi_nomor')),

    //surat_keluar_ekspedisi
    array('ekspedisi_surat_keluar_add',     2, array('sipas/surat_keluar_ekspedisi/create')),
    array('ekspedisi_surat_keluar',         2, array('sipas/surat_keluar_ekspedisi/update')),
    array('ekspedisi_surat_keluar',         1, array(
                                                'sipas/surat_keluar_ekspedisi',
                                                'sipas/surat_keluar_ekspedisi/index',
                                                'sipas/surat_keluar_ekspedisi/read')), 

    //kontak
    array('kontak',     1, array(
                            'sipas/surat_kontak',
                            'sipas/surat_kontak/index',
                            'sipas/surat_kontak/read')),

    //surat_log => 'surat' no found
    array('surat',      1, array(
                            'sipas/surat_log/create',
                            'sipas/surat_log/update',
    						'sipas/surat_log/destroy')),
    array('surat',      1, array(
                            'sipas/surat_log',
                            'sipas/surat_log/index',
                            'sipas/surat_log/ekspedisi',
                            'sipas/surat_log/cetak',
                            'sipas/surat_log/import',
                            'sipas/surat_log/next',
                            'sipas/surat_log/read')), 

    //surat_masuk
    array('masuk_insert',       1, array('sipas/surat_masuk/create')),
    array('masuk_update',       1, array('sipas/surat_masuk/update')),
    array('masuk_delete',       2, array('sipas/surat_masuk/destroy')),
    array('pengarahanmasuk',    1, array('sipas/surat_masuk/update')),
    array('registrasi',         1, array('sipas/surat_masuk/create')),
    array('registrasi',         1, array(
                                    'sipas/surat_masuk',
                                    'sipas/surat_masuk/index',
                                    'sipas/surat_masuk/read',
                                    'sipas/surat_masuk/read/not_finished',
                                    'sipas/surat_masuk/read/finished',
                                    'sipas/surat_masuk/aktif',
                                    'sipas/surat_masuk/aktif/tree',
                                    'sipas/surat_masuk/aktif/not_finished',
                                    'sipas/surat_masuk/aktif/finished',
                                    'sipas/surat_masuk/aktif7',
                                    'sipas/surat_masuk/aktif7/not_finished',
                                    'sipas/surat_masuk/aktif7/finished',
                                    'sipas/surat_masuk/aktif3',
                                    'sipas/surat_masuk/aktif3/not_finished',
                                    'sipas/surat_masuk/aktif3/finished',
                                    'sipas/surat_masuk/aktif1',
                                    'sipas/surat_masuk/aktif1/not_finished',
                                    'sipas/surat_masuk/aktif1/finished',
                                    'sipas/surat_masuk/registrasi',
                                    'sipas/surat_masuk/arah',
                                    'sipas/surat_masuk/blm_arah',
                                    'sipas/surat_masuk/nonaktif',
                                    'sipas/surat_masuk/nonaktif/not_finished',
                                    'sipas/surat_masuk/nonaktif/finished',
                                    'sipas/surat_masuk/distribusi',
                                    'sipas/surat_masuk/distribusi/not_finished',
                                    'sipas/surat_masuk/distribusi/finished',
                                    'sipas/surat_masuk/blm_distribusi',
                                    'sipas/surat_masuk/blm_distribusi/not_finished',
                                    'sipas/surat_masuk/blm_distribusi/finished',
                                    'sipas/surat_masuk/next',
                                    'sipas/surat_masuk/next/agenda',
                                    'sipas/surat_masuk/next/registrasi',
                                    'sipas/surat_masuk/resi',
                                    'sipas/surat_masuk/report',
                                    'sipas/surat_masuk/report_aktif',
                                    'sipas/surat_masuk/report_semua',
                                    'sipas/surat_masuk/report_kewenangan',
                                    'sipas/surat_masuk/report_nonaktif',
                                    'sipas/surat_masuk/report_init',
                                    'sipas/surat_masuk/report_init_semua',
                                    'sipas/surat_masuk/report_init_kewenangan',
                                    'sipas/surat_masuk/report_rekap',
                                    'sipas/surat_masuk/report_retensi',
                                    'sipas/surat_masuk/report_retensi_semua')), 

    //surat_stack => role not found
    array('surat_stack',    1, array('sipas/surat_stack/create')),
    array('surat_stack',    1, array('sipas/surat_stack/update')),
    array('surat_stack',    1, array('sipas/surat_stack/destroy')),
    array('surat_stack',    1, array('sipas/surat_stack',
                                'sipas/surat_stack/index',
                                'sipas/surat_stack/read',
                                'sipas/surat_stack/tujuan_penerima',
                                'sipas/surat_stack/tujuan_tembusan',
                                'sipas/surat_stack/print_tujuan_penerima',
                                'sipas/surat_stack/disposisi',
                                'sipas/surat_stack/koreksi')), 

    //surat_ulasan
    array('surat_internal_masuk_rating',    1, array('sipas/surat_ulasan/create')),
    array('surat_internal_masuk_rating',    1, array('sipas/surat_ulasan/update')),
    array('surat_internal_masuk_rating',    1, array('sipas/surat_ulasan/destroy')),
    array('surat_internal_masuk_rating',    1, array(
                                                'sipas/surat_ulasan',
                                                'sipas/surat_ulasan/index',
                                                'sipas/surat_ulasan/read',
                                                'sipas/surat_ulasan/report_penerima',
                                                'sipas/surat_ulasan/report_pengirim',
                                                'sipas/surat_ulasan/rating_generator')),

    //surat_unit => role not found
    array('surat_unit',     1, array('sipas/surat_unit',
                                 'sipas/surat_unit/index',
                                 'sipas/surat_unit/read')), 
    //system => role not found
    array('system',     1, array(
                             'sipas/system',
                             'sipas/system/index',
                             'sipas/system/backup_create',
                             'sipas/system/backup_state')), 
    //unit
    array('unitkerja_insert',   2, array('sipas/unit/create')),
    array('unitkerja_update',   2, array('sipas/unit/update')),
    array('unitkerja_delete',   2, array('sipas/unit/destroy')),
    array('unitkerja',          1, array(
                                    'sipas/unit',
                                    'sipas/unit/index',
                                    'sipas/unit/read',
                                    'sipas/unit/read/tree',
                                    'sipas/unit/aktif',
                                    'sipas/unit/aktif/tree',
                                    'sipas/unit/nonaktif',
                                    'sipas/unit/nonaktif/tree')),

    //unit_cakupan
    array('unitkerja_scope_insert',     2, array(
                                            'sipas/unit_cakupan/create',
                                            'sipas/unit_cakupan/update',
                                            'sipas/unit_cakupan/destroy')),
    array('unitkerja_kewenangan',       1, array(
                                            'sipas/unit_cakupan',
                                            'sipas/unit_cakupan/index',
                                            'sipas/unit_cakupan/read')),
    /*
    //user_note => role not found
    array('user_note',                                      2, array('sipas/user_note/create')),
    array('user_note',                                      2, array('sipas/user_note/mark')),
    array('user_note',                                      2, array('sipas/user_note/destroy')),
    array('user_note',                                      1, array('sipas/user_note',
                                                                     'sipas/user_note/index',
                                                                     'sipas/user_note/read')), */
    //user_log => role not found
    array('user_log',   2, array('sipas/user_log/create')),
    array('user_log',   2, array('sipas/user_log/update')),
    array('user_log',   2, array('sipas/user_log/destroy')),
    array('user_log',   1, array(
                            'sipas/user_log',
                             'sipas/user_log/index',
                             'sipas/user_log/read')), 
    //usermail => role not found
    array('usermail',   1, array('sipas/usermail',
                             'sipas/usermail/index',
                             'sipas/usermail/select',
                             'sipas/usermail/read',
                             'sipas/usermail/openmail')), 

    //staf_import
    array('staf_import',    2, array('sipas/staf/import_staf')),

    //kotak_masuk => role not found
    array('kotak_masuk',    1, array(
                                'sipas/kotak_masuk',
                                'sipas/kotak_masuk/tugassaya',
                                'sipas/kotak_masuk/tugassaya/disposisi',
                                'sipas/kotak_masuk/tugassaya/eksternal',
                                'sipas/kotak_masuk/tugassaya/internal',
                                'sipas/kotak_masuk/tugassaya/draf',
                                'sipas/kotak_masuk/teruskan',
                                'sipas/kotak_masuk/tercabut',
                                'sipas/kotak_masuk/notadinas',
                                'sipas/kotak_masuk/disposisimasuk',
                                'sipas/kotak_masuk/suratmasuk_eks',
                                'sipas/kotak_masuk/suratmasuk_int',
                                'sipas/kotak_masuk/surat_all', 
                                'sipas/kotak_masuk/penerima',
                                'sipas/kotak_masuk/penerima_new',
                                'sipas/kotak_masuk/asistensi/tugassaya',
                                'sipas/kotak_masuk/asistensi/teruskan',
                                'sipas/kotak_masuk/asistensi/tercabut',
                                'sipas/kotak_masuk/asistensi/notadinas',
                                'sipas/kotak_masuk/asistensi/disposisimasuk',
                                'sipas/kotak_masuk/asistensi/suratmasuk_eks',
                                'sipas/kotak_masuk/asistensi/suratmasuk_int',
                                'sipas/kotak_masuk/asistensi/surat_all',
                                'sipas/kotak_masuk/suratterusan')),

    //terkirim => role not found
    array('terkirim',   1, array(
                            'sipas/terkirim',
                            'sipas/terkirim/testing',
                            'sipas/terkirim/read',
                            'sipas/terkirim/tercabut',
                            'sipas/terkirim/disposisi',
                            'sipas/terkirim/notadinas',
                            'sipas/terkirim/suratterusan',
                            'sipas/terkirim/eksternal',
                            'sipas/terkirim/internal',
                            'sipas/terkirim/asistensi/read',
                            'sipas/terkirim/asistensi/tercabut',
                            'sipas/terkirim/asistensi/disposisi',
                            'sipas/terkirim/asistensi/notadinas',
                            'sipas/terkirim/asistensi/eksternal',
                            'sipas/terkirim/asistensi/internal')),

    //draft => role not found
    array('draft',      1, array(
                            'sipas/draft',
                            'sipas/draft/read',
                            'sipas/draft/blmtindak',
                            'sipas/draft/setuju',
                            'sipas/draft/tolak',
                            'sipas/draft/penyetuju',
                            'sipas/draft/asistensi/read',
                            'sipas/draft/asistensi/blmtindak',
                            'sipas/draft/asistensi/setuju',
                            'sipas/draft/asistensi/tolak')),

    //notif_agenda_surat
    array('notif_agenda_surat',     1, array(
                                        'sipas/notif_agenda',
                                        'sipas/notif_agenda/index',
                                        'sipas/notif_agenda/eksternal',
                                        'sipas/notif_agenda/internal',
                                        'sipas/notif_agenda/eksternal/masuk_blmarah',
                                        'sipas/notif_agenda/eksternal/masuk_blmdistribusi',
                                        'sipas/notif_agenda/eksternal/masuk_aktif7',
                                        'sipas/notif_agenda/eksternal/masuk_aktif3',
                                        'sipas/notif_agenda/eksternal/masuk_aktif1',
                                        'sipas/notif_agenda/eksternal/keluar_blmkirim',
                                        'sipas/notif_agenda/eksternal/keluar_blmnomor',
                                        'sipas/notif_agenda/internal/masuk_baru',
                                        'sipas/notif_agenda/internal/masuk_aktif7',
                                        'sipas/notif_agenda/internal/masuk_aktif3',
                                        'sipas/notif_agenda/internal/masuk_aktif1',
                                        'sipas/notif_agenda/internal/keluar_tolak',
                                        'sipas/notif_agenda/internal/keluar_slatolak',
                                        'sipas/notif_agenda/internal/keluar_ulasan',
                                        'sipas/notif_agenda/internal/keluar_blmnomor')),
    
    //role not found
    array('worker',     0, array(
                            'worker/scheduled_request',
                            'worker/notif',
                            'worker/notif_redis',
                            'worker/hcm_integration')),

    //role not found
    array('upload_test',    1, array(
                                'sipas/upload_test',
                                'sipas/upload_test/index',
                                'sipas/upload_test/read')),
    
    //role not found
    array('userlog_insert',     2, array('sipas/userlog/create')),
    array('userlog_update',     2, array('sipas/userlog/update')),
    array('userlog_destroy',    2, array('sipas/userlog/destroy')),
    array('userlog',            1, array(
                                    'sipas/userlog',
                                    'sipas/userlog/index',
                                    'sipas/userlog/read')),
    //backup
    array('backup',    1, array(
                                'sipas/backup/read/available',
                                'sipas/backup/read/running')),
);